-- plants and other small decorations
minetest.register_decoration({
  deco_type = "simple",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.009,
  biomes = PyuTestCore.get_flowering_biomes(),
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  decoration = PyuTestCore.registered_flowers
})

minetest.register_decoration({
  deco_type = "simple",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.032,
  biomes = PyuTestCore.get_extra_flowering_biomes(),
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  decoration = PyuTestCore.registered_flowers
})

minetest.register_decoration({
  deco_type = "simple",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.048,
  biomes = {"grassland"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  decoration = "pyutest_core:grass_plant"
})

minetest.register_decoration({
  deco_type = "simple",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.0018,
  biomes = {"grassland"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  decoration = "pyutest_core:haybale_block"
})

minetest.register_decoration({
  deco_type = "simple",
  place_on = {"pyutest_core:dirt_block", "pyutest_core:sand_block"},
  sidelen = 16,
  fill_ratio = 0.019,
  biomes = {"desert"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  decoration = "pyutest_core:deadbush"
})

minetest.register_decoration({
  deco_type = "simple",
  sidelen = 16,
  fill_ratio = 0.03,
  place_on = {"pyutest_core:water_source"},
  biomes = {"swamp", "swamp_ocean"},
  y_max = PyuTestCore_WorldTop,
  y_min = 0,
  decoration = "pyutest_core:lilypad",
  flags = "liquid_surface"
})

minetest.register_decoration({
  deco_type = "simple",
  sidelen = 16,
  fill_ratio = 0.04,
  place_on = {"group:sugarcane_spawn_on"},
  decoration = "pyutest_core:sugarcane",
  y_max = PyuTestCore_SurfaceBottom,
  y_min = 0,
  spawn_by = {"pyutest_core:water_source"},
  num_spawn_by = 1,
  height = 1,
  height_max = 4
})

-- trees
minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.004,
  biomes = {"forest", "old_growth_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.00045,
  biomes = {"grassland"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.004,
  biomes = {"forest", "old_growth_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree2"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.00085,
  biomes = {"savanna"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree4"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
  place_offset_y = 1
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"pyutest_core:mycelium_block"},
  sidelen = 16,
  fill_ratio = 0.003,
  biomes = {"mushroom_fields", "large_mushroom_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("mushroom"),
  rotation = "random",
  flags = "place_center_x, place_center_z"
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.005,
  biomes = {"old_growth_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("mushroom"),
  rotation = "random",
  flags = "place_center_x, place_center_z"
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.0015,
  biomes = {"old_growth_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree"),
  rotation = "random",
  flags = "place_center_x, place_center_z"
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.003,
  biomes = {"old_growth_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree3"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.005,
  biomes = {"taiga"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree5"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"pyutest_core:grass_block"},
  sidelen = 16,
  fill_ratio = 0.005,
  biomes = {"birch_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree6"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"pyutest_core:grass_block"},
  sidelen = 16,
  fill_ratio = 0.005,
  biomes = {"birch_forest", "old_growth_birch_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree7"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"pyutest_core:grass_block"},
  sidelen = 16,
  fill_ratio = 0.005,
  biomes = {"cherry_grove"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree8"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"pyutest_core:snow_block"},
  sidelen = 16,
  fill_ratio = 0.004,
  biomes = {"snowy_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("stree"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"pyutest_core:snow_block"},
  sidelen = 16,
  fill_ratio = 0.004,
  biomes = {"snowy_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("stree2"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.004,
  biomes = {"swamp"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree9"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"pyutest_core:grass_block"},
  sidelen = 16,
  fill_ratio = 0.004,
  biomes = {"old_growth_birch_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree10"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.016,
  biomes = {"aspen_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree11"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.008,
  biomes = {"aspen_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree12"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"pyutest_core:podzol_block"},
  sidelen = 16,
  fill_ratio = 0.019,
  biomes = {"redwood_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree13"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.010,
  biomes = {"jungle"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree14"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.008,
  biomes = {"jungle"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tree15"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"group:grass"},
  sidelen = 16,
  fill_ratio = 0.008,
  biomes = {"jungle"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("jbush"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"pyutest_core:mycelium_block"},
  sidelen = 16,
  fill_ratio = 0.006,
  biomes = {"large_mushroom_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("tall_mushroom"),
  rotation = "random",
  flags = "place_center_x, place_center_z"
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"pyutest_core:mycelium_block"},
  sidelen = 16,
  fill_ratio = 0.002,
  biomes = {"large_mushroom_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("small_mushroom"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
  place_offset_y = 1
})

minetest.register_decoration({
  deco_type = "schematic",
  place_on = {"pyutest_core:mycelium_block"},
  sidelen = 16,
  fill_ratio = 0.007,
  biomes = {"large_mushroom_forest"},
  y_max = PyuTestCore_WorldTop,
  y_min = 1,
  schematic = PyuTestCore.get_schem_path("fallen_mushroom"),
  rotation = "random",
  flags = "place_center_x, place_center_z",
  place_offset_y = 1
})
